import unit4.collectionsLib.BinTree;
import unit4.utilsLib.BinTreeUtils;

public class LeftRightGame 
{
	public static void main(String[] args) 
	{
		BinTree<Integer> gameBoard = BinTreeUtils.buildRandomTree(20, 10, 50);
		BinTreeUtils.showTree(gameBoard, "Left-Right Game");
		playLeftRight(gameBoard, 10);
	}
	
	public static void playLeftRight(BinTree<Integer> tree, int n)
	{
		//   
		Player[] players = new Player[n];
		for (int i = 0; i < players.length; i++) 
			players[i] = new Player(i+1);
		
		for (int i = 0; i < players.length; i++) 
		{
			BinTree<Integer> runner = tree;
			players[i].updateScore(runner.getInfo());
			System.out.println("Player #"+(i+1)+" start to play! ");
			while(!BinTreeUtils.isLeaf(runner))
			{
				if( (int)(Math.random()*2) == 0)
				{
					System.out.print("\ttry to go left: ");
					if(runner.getLeft() == null)
					{
						players[i].updateScore(-3);
						System.out.print("node not found -3. ");
					}
					else
					{
						runner = runner.getLeft();
						players[i].updateScore(runner.getInfo());
						System.out.print("node found +"+runner.getInfo()+". ");
					}
				}
				else
				{
					System.out.print("\ttry to go right: ");
					if(runner.getRight() == null)
					{
						players[i].updateScore(-3);
						System.out.print("node not found -3. ");
					}
					else
					{
						runner = runner.getRight();
						players[i].updateScore(runner.getInfo());
						System.out.print("node found +"+runner.getInfo()+". ");
					}
				}
				System.out.println("temp score: " + players[i].getScore());
			}
			System.out.println("\tfinish to play!");
			System.out.println();
		}
		
		
		//      
		for (int i = 1; i < players.length; i++)
		{
			for (int j = 0; j < players.length-i; j++) 
			{
				if(players[j].getScore()<players[j+1].getScore())
				{
					Player tmp = players[j];
					players[j] = players[j+1];
					players[j+1] = tmp;
				}
			}
		}
		
		//        
		System.out.println("Total players scores:");
		for (int i = 0; i < players.length; i++)
			System.out.println(players[i]);
	}
}
